/**
 * @file
 * @copyright 2020, Valentin Anger
 * @license ISC
 */

import * as irc from "../../net/irc/mod.ts";
import { Command } from "../command.ts";

class Echo implements Command {
  readonly command = "echo";

  async handle(message: irc.Message, argument: string | undefined) {
    await message.replyNotice(argument ?? "");
  }
}

export function create() {
  return new Echo();
}
