/**
 * @file
 * @copyright 2020, Valentin Anger
 * @license ISC
 */

import * as irc from "../../net/irc/mod.ts";
import { Command, Commander } from "../command.ts";

class Loaded implements Command {
  readonly admin = true;
  readonly command = "loaded";

  #commander: Commander | undefined;

  async open(commander: Commander) {
    this.#commander = commander;
  }

  async handle(message: irc.Message, argument: string | undefined) {
    message.replyNotice(this.#commander!.available().join(","));
  }
}

export function create() {
  return new Loaded();
}
