/**
 * @file
 * @copyright 2020, Valentin Anger
 * @license ISC
 */

import { Command } from "../command.ts";

class LogTest implements Command {
  readonly command = "#logtest";

  async open() {
    console.log("LOGTEST: Open");
  }
  async close() {
    console.log("LOGTEST: Close");
  }
  async channelJoin(_: never, channel: string) {
    console.log("LOGTEST: Joined " + channel);
  }
  async channelLeave(_: never, channel: string) {
    console.log("LOGTEST: Left " + channel);
  }
  async nickJoin(_: never, channel: string, nick: string) {
    console.log("LOGTEST: " + nick + " joined " + channel);
  }
  async nickLeave(_: never, channel: string, nick: string) {
    console.log("LOGTEST: " + nick + " left " + channel);
  }
}

export function create() {
  return new LogTest();
}
