/**
 * @file
 * @copyright 2020, Valentin Anger
 * @license ISC
 */

import * as irc from "../../net/irc/mod.ts";
import { Command, Commander } from "../command.ts";

class Modload implements Command {
  readonly admin = true;
  readonly command = "load";

  #commander: Commander | undefined;

  async open(commander: Commander) {
    this.#commander = commander;
  }

  async handle(message: irc.Message, argument: string | undefined) {
    if (argument == undefined) {
      return;
    }

    try {
      await this.#commander!.registerMod(argument);
    } catch (e) {
      message.replyNotice(e.toString(), true);
      return;
    }
  }
}

export function create() {
  return new Modload();
}
