/**
 * @file
 * @copyright 2020, Valentin Anger
 * @license ISC
 */

import * as irc from "../../net/irc/mod.ts";
import { Command } from "../command.ts";

class Part implements Command {
  readonly admin = true;
  readonly command = "part";

  async handle(message: irc.Message, argument: string | undefined) {
    if (argument != undefined) {
      await message.client.leaveChannel(argument);
    }
  }
}

export function create() {
  return new Part();
}
